<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/regrefine.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>regrefine.c</h1><a href="regrefine_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: regrefine.c 3037 2010-03-30 07:10:51Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init/init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="regrefine_8c.html#a445ec9c1079f67af589544afbcea155f">00030</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a445ec9c1079f67af589544afbcea155f">RegularRefinement</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <span class="keyword">const</span> <span class="keywordtype">int</span> midnod[4][4]=
<a name="l00033"></a>00033             {
<a name="l00034"></a>00034               {<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>,4,6,7},
<a name="l00035"></a>00035               {<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>,<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>,5,8},
<a name="l00036"></a>00036               {<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>,<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>,C_UNK,9},
<a name="l00037"></a>00037               {<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>,<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>,C_UNK,C_UNK}
<a name="l00038"></a>00038             };
<a name="l00039"></a>00039   <span class="keyword">const</span> <span class="keywordtype">int</span> child[8][4]=
<a name="l00040"></a>00040             {
<a name="l00041"></a>00041               {0,4,6,7},
<a name="l00042"></a>00042               {4,1,5,8},
<a name="l00043"></a>00043               {6,5,2,9},
<a name="l00044"></a>00044               {7,8,9,3},
<a name="l00045"></a>00045               {4,6,7,8},
<a name="l00046"></a>00046               {4,5,6,8},
<a name="l00047"></a>00047               {6,8,5,9},
<a name="l00048"></a>00048               {6,7,8,9}
<a name="l00049"></a>00049             };
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="keywordtype">int</span> rank,size;
<a name="l00055"></a>00055   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00056"></a>00056   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordtype">int</span> refine;
<a name="l00059"></a>00059   PetscTruth flg;
<a name="l00060"></a>00060   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-refine&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;refine,&amp;flg);CHKERRQ(ierr);
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00062"></a>00062     refine=0;
<a name="l00063"></a>00063     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00064"></a>00064       <span class="stringliteral">&quot;Option -refine not found, using default value: %i\n&quot;</span>,
<a name="l00065"></a>00065       refine
<a name="l00066"></a>00066     );
<a name="l00067"></a>00067   }
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00070"></a>00070     <span class="stringliteral">&quot;Requested number of refinement steps: %i\n&quot;</span>,
<a name="l00071"></a>00071     refine
<a name="l00072"></a>00072   );
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (rank) {
<a name="l00075"></a>00075     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> r=0;r&lt;refine;r++) {
<a name="l00076"></a>00076       Vec Mnew;
<a name="l00077"></a>00077       ierr = VecCreate(PETSC_COMM_WORLD,&amp;Mnew);CHKERRQ(ierr);
<a name="l00078"></a>00078       ierr = VecSetSizes(Mnew,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,PETSC_DECIDE);CHKERRQ(ierr);
<a name="l00079"></a>00079       ierr = VecSetFromOptions(Mnew);CHKERRQ(ierr);
<a name="l00080"></a>00080       ierr = VecSetBlockSize(Mnew,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);CHKERRQ(ierr);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082       ierr = VecDestroy(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00083"></a>00083       gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>=Mnew;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085       PetscReal devNorm;
<a name="l00086"></a>00086       devNorm=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,0.0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00089"></a>00089   }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">/* get connectivity matrix of nodes */</span>
<a name="l00092"></a>00092   <span class="comment">/* recommended size (METIS manual):</span>
<a name="l00093"></a>00093 <span class="comment">     sizeof(ia): (n_vert+1)</span>
<a name="l00094"></a>00094 <span class="comment">     sizeof(ja): 15*n_vert</span>
<a name="l00095"></a>00095 <span class="comment">  */</span>
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> r=0;r&lt;refine;r++) {
<a name="l00098"></a>00098     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Starting refinement step: %i\n&quot;</span>,r+1);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="keywordtype">int</span> *nxadj,*nadjncy;
<a name="l00101"></a>00101     ierr = <a class="code" href="mesh2dual_8c.html#abb99aec57817a85ad1c4c2552f695434">Mesh2Nodal</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;nxadj,&amp;nadjncy);CHKERRQ(ierr);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     <span class="comment">/* the last entry in nxadj (nxadj[gdata-&gt;n_vert])</span>
<a name="l00104"></a>00104 <span class="comment">       gives us the total number of vertex neighbours,</span>
<a name="l00105"></a>00105 <span class="comment">       each pair of neighbours appears twice,</span>
<a name="l00106"></a>00106 <span class="comment">       thus we have nxadj[gdata-&gt;n_vert]/2 pairs of neighbours (=edges),</span>
<a name="l00107"></a>00107 <span class="comment">       thus the total number of edges is</span>
<a name="l00108"></a>00108 <span class="comment">       nxadj[gdata-&gt;n_vert]/2</span>
<a name="l00109"></a>00109 <span class="comment">    */</span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111     <span class="keywordtype">int</span> n_edge;
<a name="l00112"></a>00112     n_edge=nxadj[gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>]/2;
<a name="l00113"></a>00113     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00114"></a>00114       <span class="stringliteral">&quot;Number of edges: %i\n&quot;</span>,
<a name="l00115"></a>00115       n_edge
<a name="l00116"></a>00116     );
<a name="l00117"></a>00117 
<a name="l00118"></a>00118     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00119"></a>00119       <span class="stringliteral">&quot;Generating a FE mesh with %i nodes and %i elements.\n&quot;</span>,
<a name="l00120"></a>00120       gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>+n_edge,
<a name="l00121"></a>00121       8*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>
<a name="l00122"></a>00122     );
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <span class="comment">/* allocate memory for ids of new vertices */</span>
<a name="l00126"></a>00126     <span class="keywordtype">int</span> *nvert;
<a name="l00127"></a>00127     ierr = PetscMalloc(2*n_edge*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;nvert);CHKERRQ(ierr);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;2*n_edge;i++) nvert[i]=<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     <span class="comment">/* reset counter for new vertices */</span>
<a name="l00132"></a>00132     <span class="keywordtype">int</span> cnt;
<a name="l00133"></a>00133     cnt=gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     <span class="comment">/* allocate memory for cartesian coordinates of old and new vertices */</span>
<a name="l00136"></a>00136     PetscReal *nvertxyz;
<a name="l00137"></a>00137     ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>+n_edge)*<span class="keyword">sizeof</span>(PetscReal),&amp;nvertxyz);CHKERRQ(ierr);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139     ierr = PetscMemcpy(nvertxyz,gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(PetscReal));CHKERRQ(ierr);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="comment">/* allocate memory for new elements */</span>
<a name="l00142"></a>00142     <span class="keywordtype">int</span> *nelevert;
<a name="l00143"></a>00143     ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*8*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;nelevert);CHKERRQ(ierr);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145     <span class="comment">/* regular refinement</span>
<a name="l00146"></a>00146 <span class="comment">       cf.</span>
<a name="l00147"></a>00147 <span class="comment">       J. Bey, Tetrahedral Grid Refinement. Computing 55 (1995) 355.</span>
<a name="l00148"></a>00148 <span class="comment">       http://www.igpm.rwth-aachen.de/bey/</span>
<a name="l00149"></a>00149 <span class="comment">       http://www.igpm.rwth-aachen.de/Download/reports/bey/tetra.ps.gz</span>
<a name="l00150"></a>00150 <span class="comment">       http://www.igpm.rwth-aachen.de/Download/reports/bey/agm.ps.gz</span>
<a name="l00151"></a>00151 <span class="comment">       p. 62</span>
<a name="l00152"></a>00152 <span class="comment">    */</span>
<a name="l00153"></a>00153     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00154"></a>00154       <span class="comment">/* get vertex ids */</span>
<a name="l00155"></a>00155       <span class="keywordtype">int</span> t_v[10];
<a name="l00156"></a>00156       ierr = PetscMemcpy(t_v,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+i*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,NV*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       <span class="comment">/* find new vertices */</span>
<a name="l00159"></a>00159       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> m=0;m&lt;NV-1;m++) {
<a name="l00160"></a>00160         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> n=m+1;n&lt;NV;n++) {
<a name="l00161"></a>00161           <span class="comment">/* we take the minimum of the &quot;parent node ids&quot; since</span>
<a name="l00162"></a>00162 <span class="comment">             they are &quot;equal partners&quot; and have only one common child,</span>
<a name="l00163"></a>00163 <span class="comment">             and we want to have a unique address of the child&#39;s id in nvert</span>
<a name="l00164"></a>00164 <span class="comment">          */</span>
<a name="l00165"></a>00165           <span class="keywordtype">int</span> lid,hid;
<a name="l00166"></a>00166           lid=PetscMin(t_v[m],t_v[n]);
<a name="l00167"></a>00167           hid=PetscMax(t_v[m],t_v[n]);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169           <span class="keywordtype">int</span> nnb;
<a name="l00170"></a>00170           nnb=nxadj[lid+1]-nxadj[lid];
<a name="l00171"></a>00171 
<a name="l00172"></a>00172           <span class="comment">/* search in list of newly created nodes first */</span>
<a name="l00173"></a>00173 
<a name="l00174"></a>00174           <span class="comment">/* go through the list of neigbours */</span>
<a name="l00175"></a>00175           <span class="keywordtype">int</span> j;
<a name="l00176"></a>00176           <span class="keywordflow">for</span> (j=0;j&lt;nnb;j++) {
<a name="l00177"></a>00177             <span class="keywordflow">if</span> (nadjncy[nxadj[lid]+j]==hid) {
<a name="l00178"></a>00178               <span class="comment">/* we found the neighbouring node */</span>
<a name="l00179"></a>00179 
<a name="l00180"></a>00180               <span class="comment">/* check if it the midnode has already been &quot;created&quot;</span>
<a name="l00181"></a>00181 <span class="comment">              */</span>
<a name="l00182"></a>00182               <span class="keywordflow">if</span> (nvert[nxadj[lid]+j] == <a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>) {
<a name="l00183"></a>00183                 nvert[nxadj[lid]+j]=cnt;
<a name="l00184"></a>00184                 <span class="comment">/* set cartesian coordinates */</span>
<a name="l00185"></a>00185                 <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00186"></a>00186                   nvertxyz[ND*cnt+k]=
<a name="l00187"></a>00187                     0.5*(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*lid+k]+gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*hid+k]);
<a name="l00188"></a>00188                 }
<a name="l00189"></a>00189                 <span class="comment">/* increase vertex counter */</span>
<a name="l00190"></a>00190                 cnt++;
<a name="l00191"></a>00191               }
<a name="l00192"></a>00192               <span class="keywordflow">break</span>;
<a name="l00193"></a>00193             }
<a name="l00194"></a>00194           }
<a name="l00195"></a>00195           <span class="comment">/* the neighbour must have been found</span>
<a name="l00196"></a>00196 <span class="comment">             (and the for loop terminated by the break command)</span>
<a name="l00197"></a>00197 <span class="comment">          */</span>
<a name="l00198"></a>00198           assert(j&lt;nxadj[lid+1]-nxadj[lid]);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200           t_v[midnod[m][n]]=nvert[nxadj[lid]+j];
<a name="l00201"></a>00201         }
<a name="l00202"></a>00202       }
<a name="l00203"></a>00203       <span class="comment">/* create new elements */</span>
<a name="l00204"></a>00204       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;8;j++) {
<a name="l00205"></a>00205         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;NV;k++) {
<a name="l00206"></a>00206           nelevert[NV*8*i+NV*j+k]=t_v[child[j][k]];
<a name="l00207"></a>00207         }
<a name="l00208"></a>00208       }
<a name="l00209"></a>00209     }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211     assert(cnt==gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>+n_edge);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213     ierr = PetscFree(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>);CHKERRQ(ierr);
<a name="l00214"></a>00214     gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>=nvertxyz;
<a name="l00215"></a>00215 
<a name="l00216"></a>00216     ierr = PetscFree(gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>);CHKERRQ(ierr);
<a name="l00217"></a>00217     gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>=nelevert;
<a name="l00218"></a>00218 
<a name="l00219"></a>00219     <span class="comment">/* interpolate magnetization on new vertices */</span>
<a name="l00220"></a>00220 
<a name="l00221"></a>00221     Vec Mnew;
<a name="l00222"></a>00222     ierr = VecCreate(PETSC_COMM_WORLD,&amp;Mnew);CHKERRQ(ierr);
<a name="l00223"></a>00223     ierr = VecSetSizes(Mnew,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>+n_edge),PETSC_DECIDE);CHKERRQ(ierr);
<a name="l00224"></a>00224     ierr = VecSetFromOptions(Mnew);CHKERRQ(ierr);
<a name="l00225"></a>00225     ierr = VecSetBlockSize(Mnew,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);CHKERRQ(ierr);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227     <span class="keywordtype">int</span> cnt2;
<a name="l00228"></a>00228     ierr = VecGetLocalSize(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;cnt2);CHKERRQ(ierr);
<a name="l00229"></a>00229     assert(cnt2==<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);
<a name="l00230"></a>00230     ierr = VecGetSize(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;cnt2);CHKERRQ(ierr);
<a name="l00231"></a>00231     assert(cnt2==<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);
<a name="l00232"></a>00232 
<a name="l00233"></a>00233     ierr = VecGetLocalSize(Mnew,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;cnt2);CHKERRQ(ierr);
<a name="l00234"></a>00234     assert(cnt2==<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>+n_edge));
<a name="l00235"></a>00235 
<a name="l00236"></a>00236     PetscReal *t_M, *t_Mnew;
<a name="l00237"></a>00237     ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;t_M);CHKERRQ(ierr);
<a name="l00238"></a>00238     ierr = VecGetArray(Mnew,&amp;t_Mnew);CHKERRQ(ierr);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Updating M\n&quot;</span>);
<a name="l00241"></a>00241 
<a name="l00242"></a>00242     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00243"></a>00243       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00244"></a>00244         t_Mnew[ND*i+k]=t_M[ND*i+k];
<a name="l00245"></a>00245       }
<a name="l00246"></a>00246       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=nxadj[i];j&lt;nxadj[i+1];j++) {
<a name="l00247"></a>00247         <span class="keywordflow">if</span> (i&lt;nadjncy[j]) {
<a name="l00248"></a>00248           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;ND;k++) {
<a name="l00249"></a>00249             t_Mnew[ND*nvert[j]+k]=
<a name="l00250"></a>00250               (t_M[ND*i+k]+t_M[ND*nadjncy[j]+k])/2.0;
<a name="l00251"></a>00251           }
<a name="l00252"></a>00252         }
<a name="l00253"></a>00253       }
<a name="l00254"></a>00254     }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;t_M);CHKERRQ(ierr);
<a name="l00257"></a>00257     ierr = VecRestoreArray(Mnew,&amp;t_Mnew);CHKERRQ(ierr);
<a name="l00258"></a>00258     ierr = VecDestroy(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00259"></a>00259     gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>=Mnew;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261     ierr = PetscFree(nvert);CHKERRQ(ierr);
<a name="l00262"></a>00262 
<a name="l00263"></a>00263     PetscReal devNorm;
<a name="l00264"></a>00264     devNorm=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,0.0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267     <span class="keywordtype">int</span> *neleprop;
<a name="l00268"></a>00268     ierr = PetscMalloc(8*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;neleprop);CHKERRQ(ierr);
<a name="l00269"></a>00269     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00270"></a>00270       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;8;j++) {
<a name="l00271"></a>00271         neleprop[8*i+j]=gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i];
<a name="l00272"></a>00272       }
<a name="l00273"></a>00273     }
<a name="l00274"></a>00274     ierr = PetscFree(gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>);CHKERRQ(ierr);
<a name="l00275"></a>00275     gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>=neleprop;
<a name="l00276"></a>00276 
<a name="l00277"></a>00277     ierr = PetscFree(nxadj);CHKERRQ(ierr);
<a name="l00278"></a>00278     ierr = PetscFree(nadjncy);CHKERRQ(ierr);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280     <span class="comment">/* update counters */</span>
<a name="l00281"></a>00281     gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>  += n_edge;
<a name="l00282"></a>00282     gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a> = gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;
<a name="l00283"></a>00283 
<a name="l00284"></a>00284     gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>   *= 8;
<a name="l00285"></a>00285     gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>  = gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;
<a name="l00286"></a>00286   }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00290"></a>00290 }
<a name="l00291"></a>00291 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

